%%%
%%% Author:
%%%   Juergen Zimmer <jzimmer@mathweb.org>
%%%   Andreas Franke <afranke@mathweb.org>
%%%
%%% Copyright:
%%%   Juergen Zimmer, 2000-2001
%%%
%%% Last change:
%%%   $Date: 2001/05/04 12:31:56 $ by $Author: afranke $
%%%   $Revision: 1.1 $
%%%
%%% This file is part of MathWeb
%%%    http://www.mathweb.org/mathweb
%%%
%%% See the file "LICENSE" or
%%%    http://www.mathweb.org/mathweb/LICENSE.html
%%% for information on usage and redistribution
%%% of this file, and for a DISCLAIMER OF ALL
%%% WARRANTIES.
%%%

functor
   
export
   call: DefaultCall
   
define

   %% ===========================
   %% a dummy handler for xml-rpc
   %% ===========================
   local
      class DefaultService

         meth init
            skip
         end
         meth add(A B $)
            A+B
         end
         meth sub(A B $)
            A-B
         end
         meth answer($)
            42
         end
         meth err()
            raise fault(1 "Dummy error") end
         end
         
      end
   in
      Service = {New DefaultService init}

      /*
      Methods = ["add" "sub" "answer"]

      proc {CallMethod Service MethodName Params ?Result}
         Meth = {StringToAtom MethodS}
         Args = {Append Params [Result]}
         Msg  = {List.toTuple Meth Args}
      in
         {Service Msg}
      end
      
      fun {IfCall Service Methods MethodName Params ?Result}
         case Methods of nil then
            raise fault(30 "Method unknown.") end
         [] M|Mr then
            if M==MethodName
            then {CallMethod Service MethodName Params ?Result}
            else {IfCall Service Mr MethodName Params ?Result}
            end
         end
      end

      proc {DefaultCall MethodNameS Params ?Result}
         {IfCall Service Methods MethodNameS Params ?Result}
      end
      */

      local
         fun {Add A B}
            {Service add(A B $)}
         end
         fun {Sub A B}
            {Service sub(A B $)}
         end
         fun {Answer}
            {Service answer($)}
         end
      in
         proc {DefaultCall MethodNameS Params ?Result}
            Fun = case MethodNameS
                  of "add"    then Add
                  [] "sub"    then Sub
                  [] "answer" then Answer 
                  else
                     raise fault(2 'unknown method') end
                  end
            Args = {Append Params [Result]}
         in
            if {Length Params}+1 == {Procedure.arity Fun} then
               {Procedure.apply Fun Args}
            else
               raise fault(3 'params count mismatch') end
            end
         end
      end
   end

end
