%%% -*- indent-tabs-mode: nil -*-
%%%
%%% Author:
%%%   Juergen Zimmer <jzimmer@mathweb.org>
%%%   Andreas Franke <afranke@mathweb.org>
%%%
%%% Copyright:
%%%   Juergen Zimmer, 2000-2001
%%%
%%% Last change:
%%%   $Date: 2001/07/20 18:17:43 $ by $Author: afranke $
%%%   $Revision: 1.4 $
%%%
%%% This file is part of MathWeb
%%%    http://www.mathweb.org/mathweb
%%%
%%% See the file "LICENSE" or
%%%    http://www.mathweb.org/mathweb/LICENSE.html
%%% for information on usage and redistribution
%%% of this file, and for a DISCLAIMER OF ALL
%%% WARRANTIES.
%%%

/**
% This is an xmlrpc handler for serving loui applets.
*/

functor

import
   XApplication
   at 'x-ozlib://mathweb/share/XApplication.ozf' 

   BrokerAccess(getBroker defaultURL)
   at 'x-ozlib://mathweb/sys/BrokerAccess.ozf'

   XmlRpcHandler('class':RpcHandler)
   at 'x-ozlib://mathweb/xmlrpc/XmlRpcHandler.ozf'
   
   AppletServer

define

   VS2S = VirtualString.toString
   
   AppName = 'appletserver'
   App     = {New XApplication.manager init}
   
   Spec = record(brokerticket(single char:[&t &b] type:string
                              default:BrokerAccess.defaultURL)
                 debug(   single char:&d type:bool   default:false)
                 loglevel(single char:&l type:int(min:0 max:9) default:1)
                )
   Args
   try
      Args = {App.getCmdArgs Spec}
   catch error(ap(usage S)...) then
      {App.showError AppName#": "#S}
      {App.exit 1}
   end
   
   %%AppletServer.connectionClass

   Broker = {BrokerAccess.getBroker App Args}.send
   
   RpcServer = {Broker request('XMLRPC_SERVER' $)}
   if RpcServer == false then
      {App.showError "XMLRPC_SERVER not found."}
      {App.exit 1}
   end

   PREFIX = case {Reverse {VS2S {RpcServer getBaseURL($)}}}
            of &/|ReverseBaseUrl then {Reverse ReverseBaseUrl}
            [] ReverseBaseUrl then {ReverseBaseUrl}
            end
   {App.showInfo PREFIX}
   
   %% ===============================================
   %% The AppletServer handles 'createILoui' requests
   %% ===============================================
   class AppletServerHandler from RpcHandler 

      meth init(RpcServer)
         GetApplet = {New AppletServer.httpHandler init} in
         {RpcServer addHttpHandler("/getILouiApplet" GetApplet)}
      end
      
      meth execute(MethodNameVS Params ?Result)
         {App.showInfo "### MethodName: "#MethodNameVS}
         case {VS2S MethodNameVS}
         of "createILoui" then
            {AppletServer.createILoui PREFIX Args Params ?Result}
         else
            RpcHandler, execute(MethodNameVS Params ?Result)
         end 
      end

   end
   Handler = {New AppletServerHandler init(RpcServer)}
   
   %% register
   {RpcServer addHandler("AppletServer" Handler)}
   
   {App.exit 0}
end




