%%
%% rpc - a test program for the mathweb xmlrpc server
%%

functor
   
import
   XApplication
   at 'x-ozlib://mathweb/share/XApplication.ozf'
   
   XmlRpcClient
   at 'x-ozlib://mathweb/xmlrpc/XmlRpcClient.ozf'

   Browser(browse: Browse)
   
define
   VS2A = VirtualString.toAtom
   VS2BS = VirtualString.toByteString
   AppName = "testbroker"
   App     = {New XApplication.manager init}
   
   Spec = record(host(single char:&h type:string default:"localhost")
                 port(single char:&p type:int    default: 1473)
                )
   Args
   try
      Args = {App.getCmdArgs Spec}
   catch error(ap(usage S)...) then
      {App.showError AppName#": "#S}
      {App.exit 1}
   end

   Url = "http://"#Args.host#":"#Args.port#"/RPC2"

   proc {Print X}
      if {IsVirtualString X}
      then {App.printInfo X}
      else {App.print X}
      end
   end
   proc {Show X}
      {Print X}
      {App.showInfo ""}
   end
   
   proc {Call Url MethodName Params ?Result}
      {App.printInfo MethodName}
      {ForAll Params
       proc {$ P}
	  {App.printInfo " "}
	  {Print P}
       end}
      {App.printInfo " ... "}
      {XmlRpcClient.execute Url MethodName Params ?Result}
      {Show Result}  
   end

   Problem = "begin_problem(Pelletier54).
list_of_descriptions.
name({*Pelletier\'s Problem No. 54*}).
author({*Christoph Weidenbach*}).
status(unsatisfiable).
description({*Problem taken in revised form from
              the \"Pelletier Collection\",
              Journal of Automated Reasoning, Vol. 2, No. 2, pages 191-216*}).
end_of_list.

list_of_symbols.
  predicates[(F,2)].
end_of_list.

list_of_formulae(axioms).
  formula(forall([U],exists([V],forall([W],equiv(F(W,V),equal(W,U)))))).
end_of_list.

list_of_formulae(conjectures).
  formula(not(exists([U],forall([V],equiv(F(V,U),forall([W],implies(F(V,W),exists([X],and(F(X,W),not(exists([Y],and(F(Y,W),F(Y,X))))))))))))).

end_of_list.

end_problem."

% MSC006_1 = "
% % BEGIN_AXIOMS
% % NAME: transitive(p)
% p(X, Z) :- p(X, Y), p(Y, Z).

% % NAME: transitive(q)
% q(X, Z) :- q(X, Y), q(Y, Z).

% % NAME: symmetric(q)
% q(Y, X) :- q(X, Y).

% % NAME: all_related(p,q)
% p(X, Y); q(X, Y).

% % NAME: not_total(p)
% - p(a, b).

% % NAME: goal 
% ?- q(c, d).

% % END_AXIOMS"

   %% create maple object
   Spass = {Call Url "Broker.getService" ["SPASS"]} % "iQEVAwUBO2gUVoAOJoiKWgYzAQHGNwf"]}
   
   %% compute 1+1
   Result = {Call Spass "prove" [Problem]}
   
   %% kill maple object
   _ = {Call Spass "kill" nil}

   {Browse Result}
   %% create maple object
%    ATP = {Call Url "Broker.getService" ["ATP"]}
   
%    %% compute 1+1
%    Result = {Call ATP "proveProblem" [unit(id: 1000234
% 					   problem: unit(protein: {VS2BS MSC006_1})
% 					   provers: {VS2BS protein}#{VS2BS bliksem}
% 					   mode:   {VS2BS all}
% 					   timeout: 30)]}
%    %% kill maple object
%    _ = {Call ATP "kill" nil}

%    {Browse Result}
%    MBASE = {Call Url "Broker.getService" ["MBASE" "adfads"]}
   
%    %% compute 1+1
%    Result = {Call MBASE "getDefinition" [1]}
%    %% kill maple object
%    _ = {Call MBASE "kill" nil}

%    {Browse Result}

%    %% create maple object
%    Maple = {Call Url "Broker.getService" ["MAPLE" "iQEVAwUBO2gUVoAOJoiKWgYzAQHGNwf"]}
   
%    %% compute 1+1
%    Sum = {Call Maple "eval" ["1+1"]}
   
%    %% kill maple object
%    _ = {Call Maple "kill" nil}
   
   %% exit
%   {App.exit if Sum==2 then 0 else 1 end}
   %% exit
%   {App.exit 0}
end


