%%
%% rpc - a test program for the mathweb xmlrpc server
%%

functor
   
import
   Application
   System
   Compiler
   
   XmlRpcClient
   at 'x-ozlib://mathweb/xmlrpc/XmlRpcClient.ozf'
   
define
   AppName = "rpc"
   Spec = record(host(single char:&h type:string default:"localhost")
                 port(single char:&p type:int    default:8080)
                 rpc2(single type:bool default:true)
                 'RPC2'(alias:rpc2)
                 handler(single char:&H type:string default:"Broker")
                 methodName(single char:&M type:string default:"ping")
                 params(multiple char:&P type:list(string) default:nil)
                )
   Args
   try
      Args = {Application.getCmdArgs Spec}
   catch error(ap(usage S)...) then
      {System.showError AppName#": "#S}
      {Application.exit 1}
   end

   Url = "http://"#Args.host#":"#Args.port#
   if Args.rpc2 then "/RPC2" else "/RPC2/"#Args.handler end
   {System.showInfo "url: "#Url}
   
   MethodName =
   if Args.rpc2 then Args.handler#"." else "" end # Args.methodName
   {System.showInfo "methodName: "#MethodName}
    
   Params = {Map Args.params Compiler.virtualStringToValue}
   {System.showInfo "params: "}
   {ForAll Params System.show}

   {System.showInfo "\n"}
   Result = {XmlRpcClient.execute Url MethodName Params}
   {System.showInfo "result: "}
   {System.show Result}
   
   {Application.exit 0}
end

