%%
%% rpc - a test program for the mathweb xmlrpc server
%%

functor
   
import
   XApplication
   at 'x-ozlib://mathweb/share/XApplication.ozf'
   
   XmlRpcClient
   at 'x-ozlib://mathweb/xmlrpc/XmlRpcClient.ozf'
   
define
   AppName = "testbroker"
   App     = {New XApplication.manager init}
   
   Spec = record(host(single char:&h type:string default:"localhost")
                 port(single char:&p type:int    default:8080)
                )
   Args
   try
      Args = {App.getCmdArgs Spec}
   catch error(ap(usage S)...) then
      {App.showError AppName#": "#S}
      {App.exit 1}
   end

   Url = "http://"#Args.host#":"#Args.port#"/RPC2"

   proc {Print X}
      if {IsVirtualString X}
      then {App.printInfo X}
      else {App.print X}
      end
   end
   proc {Show X}
      {Print X}
      {App.showInfo ""}
   end
   
   proc {Call Url MethodName Params ?Result}
      {App.printInfo MethodName}
      {ForAll Params
       proc {$ P}
	  {App.printInfo " "}
	  {Print P}
       end}
      {App.printInfo " ... "}
      {XmlRpcClient.execute Url MethodName Params ?Result}
      {Show Result}  
   end

   %% create maple object
   Maple = {Call Url "Broker.getService" ["MAPLE"]}
   
   %% compute 1+1
   Sum = {Call Maple "eval" ["1+1"]}
   
   %% kill maple object
   _ = {Call Maple "kill" nil}

   %% exit
   {App.exit if Sum==2 then 0 else 1 end}
end


