%%% -*- indent-tabs-mode: nil -*-
%%%
%%% Author:
%%%   Andreas Franke <afranke@mathweb.org>
%%%   Juergen Zimmer <jzimmer@mathweb.org>
%%%
%%% Copyright:
%%%   Juergen Zimmer, 2001
%%%
%%% Last change:
%%%   $Date: 2001/09/23 13:34:30 $ by $Author: afranke $
%%%   $Revision: 1.3 $
%%%
%%% This file is part of MathWeb
%%%    http://www.mathweb.org/mathweb
%%%
%%% See the file "LICENSE" or
%%%    http://www.mathweb.org/mathweb/LICENSE.html
%%% for information on usage and redistribution
%%% of this file, and for a DISCLAIMER OF ALL
%%% WARRANTIES.
%%%

%%
%% printer for xmlrpc requests and responses
%%

functor
   
import
   Type(ask)
   
   VALUE('class':ValueWriter)
   at 'x-ozlib://mathweb/xmlrpc/value.printer.ozf'
   
export
   'class': XmlrpcWriter
   
define

   %%  TODO ! 
   %% please add
   %%   Content-encoding: us-ascii
   %%  to the header

   %%
   %% write OpenMath objects
   %%
   local
      VS2BS = VirtualString.toByteString
   in
      class Self = XmlrpcWriter
         from ValueWriter

            %%
            %% request
            %%
         meth 'write_methodCall'(MethodName Params)
            {self startTag(methodCall)}
            Self, 'write_methodName'(MethodName)
            Self, 'write_params'(Params)
            {self endTag(methodCall)}
         end
         meth 'write_methodName'(X)
            {Type.ask.virtualString X}
            {self startTag(methodName)}
            {self write(vs:X)}
            {self endTag(methodName)}
         end
         meth 'write_params'(X)
            {self startTag(params)}
            {ForAll X
             proc {$ Param}
                Self, 'write_param'(Param)
             end}
            {self endTag(params)}
         end
         meth 'write_param'(X)
            {self startTag(param)}
            Self, 'write_value'(X)
            {self endTag(param)}
         end

         %%
         %% response
         %%
         meth 'write_methodResponse'(X)
            {self startTag(methodResponse)}
            case X
            of params(Y) then
               Self, 'write_params'(Y)
            [] fault(Y) then
               Self, 'write_fault'(Y)
            end
            {self endTag(methodResponse)}
         end
         meth 'write_fault'(X)
            {self startTag(fault)}
            ValueWriter, 'write_value'(X)
            {self endTag(fault)}
         end
         %%
         meth writeResult(Result)
            Self, 'write_methodResponse'(params([Result]))
         end
         meth writeFault(FaultCode FaultString)
            FaultRec = unit(faultCode:   FaultCode
                            faultString: {VS2BS FaultString})
         in
            Self, 'write_methodResponse'(fault(FaultRec))
         end
      end
   end
end
