%%
%% parser semantics for xml-rpc methodCall and methodResponse
%%

functor

import
   SemValue at 'x-ozlib://mathweb/xmlrpc/value.sem.ozf'

export
   'class': SemXmlrpc
   
define

   VS2S = VirtualString.toString
   
   class SemXmlrpc
      from SemValue.'class'
         
      meth 'make_methodCall'(E $)
         MethodName # Params = E.content in
         methodCall(methodName: MethodName
                    params:     Params)
      end
      meth 'make_methodName'(E $)
         {VS2S E.content}
      end
      meth 'make_params'(E $)
         E.content
      end
      meth 'make_param'(E $)
         E.content
      end
      meth 'make_methodResponse'(E $)
         case E.model
         of params then
            case E.content of [Result] then
               ok(Result)
            else
               raise tooManyParamsInResponse(E.content) end
            end
         [] fault then
            {Adjoin E.content fault}
         else
            raise unknownResponse(E.model) end
         end
      end
      meth 'make_fault'(E $)
         E.content
      end
   end
end
